// LayerView.cpp : CLayerView NX̎
//

#include "stdafx.h"
#include "Layer.h"

#include "LayerDoc.h"
#include "LayerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "MainFrm.h"
extern CMainFrame* g_pMainFrame;
#include "DlgOption.h"

// CLayerView

IMPLEMENT_DYNCREATE(CLayerView, CView)

BEGIN_MESSAGE_MAP(CLayerView, CView)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_VIEW_SHADING, &CLayerView::OnViewShading)
	ON_WM_KEYDOWN()
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_MIYA, OnUpdateIndicatorMiya)
	ON_COMMAND(ID_VIEW_ALBEDO, &CLayerView::OnViewAlbedo)
	ON_COMMAND(ID_VIEW_ZENITH, &CLayerView::OnViewZenith)
	ON_COMMAND(ID_VIEW_AZIMUTH, &CLayerView::OnViewAzimuth)
	ON_COMMAND(ID_VIEW_NEEDLE, &CLayerView::OnViewNeedle)
	ON_COMMAND(ID_VIEW_COLOR, &CLayerView::OnViewColor)
	ON_UPDATE_COMMAND_UI(ID_VIEW_COLOR, &CLayerView::OnUpdateViewColor)
	ON_COMMAND(ID_CALC_CALC, &CLayerView::OnCalcCalc)
	ON_COMMAND(ID_OPTION_OPTION, &CLayerView::OnOptionOption)
	ON_COMMAND(ID_CALC_ITERATE, &CLayerView::OnCalcIterate)
	ON_COMMAND(ID_VIEW_ALBEDONEW, &CLayerView::OnViewAlbedonew)
	ON_COMMAND(ID_VIEW_ZENITHNEW, &CLayerView::OnViewZenithnew)
	ON_COMMAND(ID_VIEW_AZIMUTHNEW, &CLayerView::OnViewAzimuthnew)
	ON_COMMAND(ID_VIEW_NEEDLENEW, &CLayerView::OnViewNeedlenew)
	ON_COMMAND(ID_VIEW_RENDER, &CLayerView::OnViewRender)
END_MESSAGE_MAP()

// CLayerView RXgNV/fXgNV

CLayerView::CLayerView()
{
	int i;
	int x, y;
	int c;

	// z̃TCYݒ
	PROCESSMAX = 100;
	WIDTH = 640;
	HEIGHT = 480;
	IMAGEMIN = 3;
	IMAGEMAX = 10;

	// vO}̃~X`FbN
	if(WIDTH % 4 != 0) AfxMessageBox("WIDTH4̔{ɂĂ");
	if(IMAGEMIN < 3) AfxMessageBox("IMAGEMIN3ȏɂĂ");
	if(IMAGEMIN > IMAGEMAX) AfxMessageBox("IMAGEMAXIMAGEMINȏɂĂ");

	// z̃m
	processdone = new bool[PROCESSMAX];
	normal = new double**[WIDTH];
	albedo = new double**[WIDTH];
	normalnew = new double**[WIDTH];
	albedonew = new double**[WIDTH];
	lightpos = new double*[IMAGEMAX];
	needleimage = new unsigned char**[WIDTH];
	renderimage = new unsigned char**[WIDTH];
	shadingimage = new unsigned char***[IMAGEMAX];
	screendata = new unsigned char[4 * WIDTH * HEIGHT];
	if(processdone == 0 ||
		normal == 0 ||
		albedo == 0 ||
		normalnew == 0 ||
		albedonew == 0 ||
		needleimage == 0 ||
		renderimage == 0 ||
		shadingimage == 0 ||
		lightpos == 0 ||
		screendata == 0)
	{
		AfxMessageBox("܂");
		return;
	}
	for(x = 0; x < WIDTH; x++)
	{
		normal[x] = new double*[HEIGHT];
		albedo[x] = new double*[HEIGHT];
		normalnew[x] = new double*[HEIGHT];
		albedonew[x] = new double*[HEIGHT];
		needleimage[x] = new unsigned char*[HEIGHT];
		renderimage[x] = new unsigned char*[HEIGHT];
		if(normal[x] == 0 ||
			albedo[x] == 0 ||
			normalnew[x] == 0 ||
			albedonew[x] == 0 ||
			needleimage[x] == 0 ||
			renderimage[x] == 0)
		{
			AfxMessageBox("܂");
			return;
		}
		for(y = 0; y < HEIGHT; y++)
		{
			normal[x][y] = new double[3];
			albedo[x][y] = new double[3];
			normalnew[x][y] = new double[3];
			albedonew[x][y] = new double[3];
			needleimage[x][y] = new unsigned char[3];
			renderimage[x][y] = new unsigned char[3];
			if(normal[x][y] == 0 ||
				albedo[x][y] == 0 ||
				normalnew[x][y] == 0 ||
				albedonew[x][y] == 0 ||
				needleimage[x][y] == 0 ||
				renderimage[x][y] == 0)
			{
				AfxMessageBox("܂");
				return;
			}
		}
	}
	for(i = 0; i < IMAGEMAX; i++)
	{
		lightpos[i] = new double[3];
		shadingimage[i] = new unsigned char**[WIDTH];
		if(lightpos[i] == 0 ||
			shadingimage[i] == 0)
		{
			AfxMessageBox("܂");
			return;
		}
		for(x = 0; x < WIDTH; x++)
		{
			shadingimage[i][x] = new unsigned char*[HEIGHT];
			if(shadingimage[i][x] == 0)
			{
				AfxMessageBox("܂");
				return;
			}
			for(y = 0; y < HEIGHT; y++)
			{
				shadingimage[i][x][y] = new unsigned char[3];
				if(shadingimage[i][x][y] == 0)
				{
					AfxMessageBox("܂");
					return;
				}
			}
		}
	}

	// l
	EPS = 1.0e-15;
	INF = 1.0e+38;
	if(sizeof(int) == 4) INTINF = 0x7fff;
	else {INTINF = 0; AfxMessageBox("int^32bitł͂܂");}
	PI = 3.1415926535897932384626433832795;
	MENUVIEW = 1; // [\]j[j[Ŝ̉Ԗڂ̍ڂ
	COLR = 0;
	COLG = 1;
	COLB = 2;
	AXISX = 0;
	AXISY = 1;
	AXISZ = 2;
	MIYA_SHADING = 0;
	MIYA_ALBEDO = 1;
	MIYA_ZENITH = 2;
	MIYA_AZIMUTH = 3;
	MIYA_NEEDLE = 4;
	MIYA_ALBEDONEW = 5;
	MIYA_ZENITHNEW = 6;
	MIYA_AZIMUTHNEW = 7;
	MIYA_NEEDLENEW = 8;
	MIYA_RENDER = 9;
	MIYA_NORMAL = 20;
	MIYA_NORMALNEW = 21;
	maxmenu = 10;
	viewmode = 0;
	colormode = true;
	CheckView(0);
	imageview = 0;
	imagenum = 0;
	sFileName = "layerdata";
	ALBEDOMED = 1;
	ALBEDOAVG = 1.0;
	NORMALMED = 1;
	NORMALAVG = 1.0;
	LOOPNUM = 500;

	// z
	for(i = 0; i < PROCESSMAX; i++) processdone[i] = false;
	for(i = 0; i < 4 * WIDTH * HEIGHT; i++) screendata[i] = 0;
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			for(c = 0; c < 3; c++)
			{
				needleimage[x][y][c] = 0;
			}
		}
	}
}

CLayerView::~CLayerView()
{
}

BOOL CLayerView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

// CLayerView `

void CLayerView::OnDraw(CDC* pDC)
{
	CBitmap bitmap;
	CDC dcMemory;
	int w, h;

	if(processdone[viewmode] == false) return;

	// ̂̉摜\
	w = WIDTH;
	h = HEIGHT;
	if(w % 4 > 0){}//??
	bitmap.CreateCompatibleBitmap(pDC, w, h);
	bitmap.SetBitmapBits(w * h * 4, screendata);
	dcMemory.CreateCompatibleDC(pDC);
	dcMemory.SelectObject(&bitmap);
	pDC->BitBlt(0, 0, w, h, &dcMemory, 0, 0, SRCCOPY);
	bitmap.DeleteObject();
	dcMemory.DeleteDC();
}


// CLayerView ff

#ifdef _DEBUG
void CLayerView::AssertValid() const
{
	CView::AssertValid();
}

void CLayerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CLayerDoc* CLayerView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CLayerDoc)));
	return (CLayerDoc*)m_pDocument;
}
#endif //_DEBUG


// CLayerView bZ[W nh

void CLayerView::CheckView(int miyamenu)
{
	g_pMainFrame->GetMenu()->GetSubMenu(MENUVIEW)->CheckMenuRadioItem(0, maxmenu - 1, miyamenu, MF_BYPOSITION);
}

void CLayerView::OnViewShading()
{
	viewmode = MIYA_SHADING;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewAlbedo()
{
	viewmode = MIYA_ALBEDO;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewZenith()
{
	viewmode = MIYA_ZENITH;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewAzimuth()
{
	viewmode = MIYA_AZIMUTH;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewNeedle()
{
	viewmode = MIYA_NEEDLE;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewAlbedonew()
{
	viewmode = MIYA_ALBEDONEW;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewZenithnew()
{
	viewmode = MIYA_ZENITHNEW;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewAzimuthnew()
{
	viewmode = MIYA_AZIMUTHNEW;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewNeedlenew()
{
	viewmode = MIYA_NEEDLENEW;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnViewRender()
{
	viewmode = MIYA_RENDER;
	CheckView(viewmode);
	CreateImages();
	Invalidate();
}

void CLayerView::OnUpdateViewColor(CCmdUI *pCmdUI)
{
	if(colormode) pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}

void CLayerView::OnViewColor()
{
	if(colormode) colormode = false;
	else colormode = true;
	CreateImages();
	Invalidate();
}

void CLayerView::OnOptionOption()
{
	DlgOption dlg;
	dlg.Width = WIDTH;
	dlg.Height = HEIGHT;
	dlg.AlbedoMed = ALBEDOMED;
	dlg.AlbedoAvg = ALBEDOAVG;
	dlg.NormalMed = NORMALMED;
	dlg.NormalAvg = NORMALAVG;
	dlg.Loop = LOOPNUM;
	if(dlg.DoModal() == IDOK)
	{
		if(dlg.AlbedoMed >= 0 && dlg.NormalMed >= 0 && dlg.AlbedoAvg >= 0.0 && dlg.NormalAvg >= 0.0 && dlg.Loop >= 0)
		{
			ALBEDOMED = dlg.AlbedoMed;
			ALBEDOAVG = dlg.AlbedoAvg;
			NORMALMED = dlg.NormalMed;
			NORMALAVG = dlg.NormalAvg;
			LOOPNUM = dlg.Loop;
		}
		else
		{
			AfxMessageBox("0ȏ̒lݒ肵Ă");
		}
	}
}

void CLayerView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if(nChar == VK_UP)
	{
		imageview--;
		if(imageview < 0) imageview = imagenum - 1;
	}
	if(nChar == VK_DOWN)
	{
		imageview++;
		if(imageview > imagenum - 1) imageview = 0;
	}

	CreateImages();
	Invalidate(FALSE);
	UpdateMiyaStatusbar();

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CLayerView::UpdateMiyaStatusbar(void)
{
	CString s;
	s.Format("% 4d/% 4d", imageview + 1, imagenum);
	g_pMainFrame->m_wndStatusBar.SetPaneText(1, s, TRUE);
}

void CLayerView::OnUpdateIndicatorMiya(CCmdUI *pCmdUI)
{
	pCmdUI->Enable();
}

void CLayerView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	UpdateMiyaStatusbar();
}

// t@CJ
void CLayerView::OnFileOpen()
{
	POSITION pos;
	CFileDialog *cfd;
	CString sFileEach;
	CString sFilter;
	int numimg;
	int numlight;
	int numfile;
	const int maxfile = IMAGEMAX * 2;
	CString* sFileList;
	int inx;
	CString str;
	int* fileext;
	const int fileimg = 1;
	const int filelight = 2;
	int* fileid;
	char* ctemp;
	int i;
	int x, y;
	int c;
	int n;
	int j;
	bool* filereadimage;
	bool* filereadlight;
	int* indexlist;

	// ̊m
	sFileList = new CString[maxfile];
	fileext = new int[maxfile];
	fileid = new int[maxfile];
	filereadimage = new bool[IMAGEMAX];
	filereadlight = new bool[IMAGEMAX];
	indexlist = new int[IMAGEMAX];
	ctemp = new char[2048 + 1];
	if(sFileList == 0 ||
		fileext == 0 ||
		fileid == 0 ||
		filereadimage == 0 ||
		filereadlight == 0 ||
		indexlist == 0 ||
		ctemp == 0)
	{
		AfxMessageBox("܂");
		return;
	}
	ctemp[0] = '\0';

	// 
	for(i = 0; i < IMAGEMAX; i++)
	{
		filereadimage[i] = false;
		filereadlight[i] = false;
		indexlist[i] = -1;
	}

	// t@CJ
	sFilter.Format("*.*.%d.%d.uchar.img.lay;*.*.light.lay", WIDTH, HEIGHT);
	cfd = new CFileDialog(true, NULL, NULL,
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_ALLOWMULTISELECT | OFN_EXPLORER | OFN_LONGNAMES,
		"ǂݍނׂt@C (" + sFilter + ")|" + sFilter + "|SẴC[t@C (*.lay)|*.lay|SẴt@C (*.*)|*.*||",
		AfxGetApp()->GetMainWnd());
	if(cfd == 0) return;
	cfd->m_ofn.lpstrTitle = "t@CƉ摜t@CJ܂";
	cfd->m_ofn.lpstrFile = ctemp;
	cfd->m_ofn.nMaxFile = 2048;
	numimg = 0;
	numlight = 0;
	numfile = 0;
	if(cfd->DoModal() == IDOK)
	{
		pos = cfd->GetStartPosition();
		while(pos != NULL)
		{
			// Y`FbN
			if(numfile > maxfile - 1) numfile = maxfile - 1;

			// t@C擾
			sFileEach = cfd->GetNextPathName(pos);
			sFileList[numfile] = sFileEach;

			// gqt@C̎ނo
			fileext[numfile] = 0;
			inx = sFileEach.ReverseFind('.');
			if(inx == -1) continue;
			if(sFileEach.Mid(inx) == ".lay")
			{
				str = sFileEach.Left(inx);
				inx = str.ReverseFind('.');
				if(inx == -1) continue;
				if(str.Mid(inx) == ".light")
				{
					numlight++;
					fileext[numfile] = filelight;
				}
				else if(str.Mid(inx) == ".img")
				{
					str = str.Left(inx);
					inx = str.ReverseFind('.');
					if(inx == -1) continue;
					if(str.Mid(inx) == ".uchar")
					{
						str = str.Left(inx);
						inx = str.ReverseFind('.');
						n = atoi(str.Mid(inx + 1));
						if(n == HEIGHT)
						{
							str = str.Left(inx);
							inx = str.ReverseFind('.');
							n = atoi(str.Mid(inx + 1));
							if(n == WIDTH)
							{
								numimg++;
								fileext[numfile] = fileimg;
							}
						}
					}
				}

				// t@C̔ԍo
				str = str.Left(inx);
				inx = str.ReverseFind('.');
				n = atoi(str.Mid(inx + 1));
				if(n < 0 || n >= IMAGEMAX) numimg = numlight = IMAGEMAX + 9999;
				fileid[numfile] = n;
			}

			// Y1₷
			numfile++;
		}
	}
	delete cfd;

	// t@Cǂݍ
	if(numimg >= IMAGEMIN &&
		numimg <= IMAGEMAX &&
		numlight >= IMAGEMIN &&
		numlight <= IMAGEMAX &&
		numimg == numlight)
	{
		// f[^
		for(i = 0; i < IMAGEMAX; i++)
		{
			// xECyCzOƂ
			lightpos[i][AXISX] = 0.0;
			lightpos[i][AXISY] = 0.0;
			lightpos[i][AXISZ] = 0.0;
			for(x = 0; x < WIDTH; x++)
			{
				for(y = 0; y < HEIGHT; y++)
				{
					for(c = 0; c < 3; c++)
					{
						shadingimage[i][x][y][c] = 0;
					}
				}
			}
		}

		// t@Cǂݍ݃`FbN
		for(i = 0; i < numfile; i++)
		{
			if(fileext[i] == fileimg)
			{
				filereadimage[fileid[i]] = true;
			}
			if(fileext[i] == filelight)
			{
				filereadlight[fileid[i]] = true;
			}
		}

		// t@C̔ԍt
		inx = 0;
		imagenum = 0;
		for(i = 0; i < IMAGEMAX; i++)
		{
			if(filereadimage[i] && filereadlight[i])
			{
				indexlist[i] = inx;
				inx++;
				imagenum++;
			}
			else
			{
				indexlist[i] = -1;
			}
		}

		// t@Cǂݍ
		for(i = 0; i < numfile; i++)
		{
			inx = indexlist[fileid[i]];
			if(inx >= 0)
			{
				if(fileext[i] == fileimg) ReadData(sFileList[i], inx);
				if(fileext[i] == filelight) ReadLight(sFileList[i], inx);
			}
		}

		// t@C𒊏o
		str = sFileName;
		for(i = 0; i < numfile; i++)
		{
			sFileEach = sFileList[i];
			inx = sFileEach.ReverseFind('\\');
			sFileEach = sFileEach.Mid(inx + 1);
			if(sFileEach == "") continue;
			if(i == 0)
			{
				sFileName = sFileEach;
				continue;
			}
			for(j = 0; j < sFileName.GetLength(); j++)
			{
				if(j >= sFileEach.GetLength()) break;
				if(sFileName[j] != sFileEach[j]) break;
			}
			sFileName = sFileName.Left(j);
		}
		if(sFileName == "") sFileName = str;
		else if(sFileName.Right(1) == ".") sFileName = sFileName.Left(sFileName.GetLength() - 1);

		// ㏈
		processdone[MIYA_SHADING] = true;
		CreateImages();
		Invalidate();
		UpdateMiyaStatusbar();
	}

	// 
	delete [] ctemp;
	delete [] sFileList;
	delete [] fileext;
	delete [] fileid;
	delete [] filereadimage;
	delete [] filereadlight;
	delete [] indexlist;
}

// f[^t@Cǂݍ
void CLayerView::ReadData(CString filename, int id)
{
	CWaitCursor wait;
	CFile cf(filename, CFile::modeRead);
	CArchive ar(&cf, CArchive::load);
	int x, y;
	int c;

	// f[^ǂݍ
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			for(c = 0; c < 3; c++)
			{
				ar >> shadingimage[id][x][y][c];
			}
		}
	}

	ar.Close();
	cf.Close();
}

// ʒut@Cǂݍ
void CLayerView::ReadLight(CString filename, int id)
{
	CWaitCursor wait;
	CString strData;
	CFile cf(filename, CFile::modeRead);
	CArchive ar(&cf, CArchive::load);
	int i;

	// f[^ǂݍ
	for(i = 0; i < 3; i++)
	{
		ar.ReadString(strData);
		lightpos[id][i] = atof(strData);
	}

	ar.Close();
	cf.Close();
}

// t@Cۑ
void CLayerView::OnFileSaveAs()
{
	CWinApp* theApp = AfxGetApp();
	CFileDialog *cfd;
	CString s;
	int c;
	bool colormodebackup;
	int viewmodebackup;
	int imageviewbackup;
	CString sc;
	int i;

	colormodebackup = colormode;
	viewmodebackup = viewmode;
	imageviewbackup = imageview;

	for(c = 0; c < 2; c++)
	{
		if(c == 0)
		{
			colormode = true;
			sc = "color";
		}
		else
		{
			colormode = false;
			sc = "gray";
		}

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-albedo-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "Axh摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_ALBEDO;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-zenith-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "VpƉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_ZENITH;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-azimuth-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "ʊpӉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_AZIMUTH;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-needle-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "j[h}bv摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_NEEDLE;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-albedonew-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "XVꂽAxh摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_ALBEDONEW;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-zenithnew-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "XVꂽVpƉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_ZENITHNEW;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-azimuthnew-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "XVꂽʊpӉ摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_AZIMUTHNEW;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;

		cfd = new CFileDialog(FALSE, "bmp", sFileName + "-needlenew-" + sc + ".bmp",
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "XVꂽj[h}bv摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			viewmode = MIYA_NEEDLENEW;
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;
	}

	s = sFileName;
	s.AppendFormat(".%d.%d.normal.lay", WIDTH, HEIGHT);
	cfd = new CFileDialog(FALSE, "lay", s,
		OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
		"C[t@C (*.lay)|*.lay|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "@t@Cۑ܂";
	if(cfd->DoModal() == IDOK) WriteData(cfd->GetPathName(), MIYA_NORMAL);
	delete cfd;

	s = sFileName;
	s += "-new";
	s.AppendFormat(".%d.%d.normal.lay", WIDTH, HEIGHT);
	cfd = new CFileDialog(FALSE, "lay", s,
		OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
		"C[t@C (*.lay)|*.lay|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "XVꂽ@t@Cۑ܂";
	if(cfd->DoModal() == IDOK) WriteData(cfd->GetPathName(), MIYA_NORMALNEW);
	delete cfd;

	colormode = true;
	viewmode = MIYA_RENDER;
	for(i = 0; i < imagenum; i++)
	{
		imageview = i;
		s = sFileName;
		s.AppendFormat("-render-%02d.bmp", i);
		cfd = new CFileDialog(FALSE, "bmp", s,
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			"摜t@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
		cfd->m_ofn.lpstrTitle = "_O摜t@Cۑ܂";
		if(cfd->DoModal() == IDOK)
		{
			CreateImages();
			WriteImage(cfd->GetPathName());
		}
		delete cfd;
	}

	colormode = colormodebackup;
	viewmode = viewmodebackup;
	imageview = imageviewbackup;
}

// BMPt@C
void CLayerView::WriteImage(CString filename)
{
	CWaitCursor wait;
	BITMAPFILEHEADER bmfh;
	BITMAPINFOHEADER bmih;
	int i, j;
	unsigned char* ras;
	int x, y;
	int mx, my;
	unsigned char cr, cg, cb;
	int w, h;
	int k;
	CFile cf(filename, CFile::modeWrite | CFile::modeCreate);
	CArchive ar(&cf, CArchive::store);

	w = WIDTH;
	h = HEIGHT;

	bmfh.bfType = 0x4D42;
	bmfh.bfOffBits = 54;
	bmih.biSize = 40;
	bmih.biBitCount = 24;
	bmih.biWidth = w;
	bmih.biHeight = h;
	bmih.biPlanes = 1;
	bmih.biCompression = BI_RGB;
	bmih.biSizeImage = 0;
	bmih.biXPelsPerMeter = 0;
	bmih.biYPelsPerMeter = 0;
	bmih.biClrUsed = 0;
	bmih.biClrImportant = 0;
	j = w * 3;
	j = ((j + 3) / 4) * 4;
	ras = new unsigned char [j * h];
	for(i = 0; i < j * h; i++) ras[i] = 0;
	for(y = 0; y < h; y++)
	{
		my = h - 1 - y;
		for(x = 0; x < w; x++)
		{
			mx = x * 3;
			i = my * j + mx;
			if(w % 4 == 0) k = y * w * 4 + x * 4;
			else k = y * w * 4 + x * 4;//??
			cb = screendata[k + 0];
			cg = screendata[k + 1];
			cr = screendata[k + 2];
			ras[i + 0] = cb;
			ras[i + 1] = cg;
			ras[i + 2] = cr;;
		}
	}
	bmfh.bfSize = 54 + j * h;
	ar.Write((void*)&bmfh, 14);
	ar.Write((void*)&bmih, 40);
	ar.Write(ras, j * h);
	delete ras;

	ar.Close();
	cf.Close();
}

// f[^t@C
void CLayerView::WriteData(CString filename, int filemode)
{
	CWaitCursor wait;
	CFile cf(filename, CFile::modeWrite | CFile::modeCreate);
	CArchive ar(&cf, CArchive::store);
	int x, y;
	int c;

	// f[^
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			for(c = 0; c < 3; c++)
			{
				if(filemode == MIYA_NORMAL) ar << normal[x][y][c];
				if(filemode == MIYA_NORMALNEW) ar << normalnew[x][y][c];
			}
		}
	}

	ar.Close();
	cf.Close();
}

// 摜𐶐
void CLayerView::CreateImages(void)
{
	CWaitCursor wait;
	int x, y;
	int i;
	double p;
	int r, g, b;
	int m;

	// f[^`FbN
	if(!processdone[viewmode])
	{
		for(i = 0; i < 4 * WIDTH * HEIGHT; i++) screendata[i] = 0;
		return;
	}

	// 摜`
	if(viewmode == MIYA_NEEDLE) CreateNeedleImage(MIYA_NEEDLE);
	if(viewmode == MIYA_NEEDLENEW) CreateNeedleImage(MIYA_NEEDLENEW);
	if(viewmode == MIYA_RENDER) CreateRenderImage();

	// 摜f[^쐬
	i = 0;
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			m = -1;
			if(viewmode == MIYA_SHADING)
			{
				r = (int)shadingimage[imageview][x][y][COLR];
				g = (int)shadingimage[imageview][x][y][COLG];
				b = (int)shadingimage[imageview][x][y][COLB];
				m = 2;
			}
			if(viewmode == MIYA_ALBEDO)
			{
				r = (int)floor(albedo[x][y][COLR]);
				g = (int)floor(albedo[x][y][COLG]);
				b = (int)floor(albedo[x][y][COLB]);
				m = 2;
			}
			if(viewmode == MIYA_ZENITH)
			{
				p = normal[x][y][AXISZ];
				if(p < 0.0) p = 0.0;
				if(p > 1.0) p = 1.0;
				p = acos(p);
				p = p / (PI / 2.0);
				m = 0;
			}
			if(viewmode == MIYA_AZIMUTH)
			{
				p = atan2(normal[x][y][AXISY], normal[x][y][AXISX]);
				if(p < 0.0) p += PI * 2.0;
				p = p / (PI * 2.0);
				m = 1;
			}
			if(viewmode == MIYA_NEEDLE)
			{
				r = (int)needleimage[x][y][COLR];
				g = (int)needleimage[x][y][COLG];
				b = (int)needleimage[x][y][COLB];
				m = 2;
			}
			if(viewmode == MIYA_ALBEDONEW)
			{
				r = (int)floor(albedonew[x][y][COLR]);
				g = (int)floor(albedonew[x][y][COLG]);
				b = (int)floor(albedonew[x][y][COLB]);
				m = 2;
			}
			if(viewmode == MIYA_ZENITHNEW)
			{
				p = normalnew[x][y][AXISZ];
				if(p < 0.0) p = 0.0;
				if(p > 1.0) p = 1.0;
				p = acos(p);
				p = p / (PI / 2.0);
				m = 0;
			}
			if(viewmode == MIYA_AZIMUTHNEW)
			{
				p = atan2(normalnew[x][y][AXISY], normalnew[x][y][AXISX]);
				if(p < 0.0) p += PI * 2.0;
				p = p / (PI * 2.0);
				m = 1;
			}
			if(viewmode == MIYA_NEEDLENEW)
			{
				r = (int)needleimage[x][y][COLR];
				g = (int)needleimage[x][y][COLG];
				b = (int)needleimage[x][y][COLB];
				m = 2;
			}
			if(viewmode == MIYA_RENDER)
			{
				r = (int)renderimage[x][y][COLR];
				g = (int)renderimage[x][y][COLG];
				b = (int)renderimage[x][y][COLB];
				m = 2;
			}

			if(m == 0)
			{
				if(colormode)
				{
					if(p < 0.2)
					{
						p = p * 5.0;
						r = 0;
						g = 0;
						b = (int)(p * 255.0);
					}
					else if(p < 0.4)
					{
						p = p - 0.2;
						p = p * 5.0;
						r = 0;
						g = (int)(p * 255.0);
						b = 255;
					}
					else if(p < 0.6)
					{
						p = p - 0.4;
						p = p * 5.0;
						r = 0;
						g = 255;
						b = (int)((1.0 - p) * 255.0);
					}
					else if(p < 0.8)
					{
						p = p - 0.6;
						p = p * 5.0;
						r = (int)(p * 255.0);
						g = 255;
						b = 0;
					}
					else
					{
						p = p - 0.8;
						p = p * 5.0;
						r = 255;
						g = (int)((1.0 - p) * 255.0);
						b = 0;
					}
				}
				else
				{
					r = g = b = (int)(p * 255.0);
				}
			}
			else if(m == 1)
			{
				if(colormode)
				{
					if(p < 1.0 / 6.0)
					{
						p = p * 6.0;
						r = 255;
						g = (int)(p * 255.0);
						b = 0;
					}
					else if(p < 2.0 / 6.0)
					{
						p = p - 1.0 / 6.0;
						p = p * 6.0;
						r = (int)((1.0 - p) * 255.0);
						g = 255;
						b = 0;
					}
					else if(p < 3.0 / 6.0)
					{
						p = p - 2.0 / 6.0;
						p = p * 6.0;
						r = 0;
						g = 255;
						b = (int)(p * 255.0);
					}
					else if(p < 4.0 / 6.0)
					{
						p = p - 3.0 / 6.0;
						p = p * 6.0;
						r = 0;
						g = (int)((1.0 - p) * 255.0);
						b = 255;
					}
					else if(p < 5.0 / 6.0)
					{
						p = p - 4.0 / 6.0;
						p = p * 6.0;
						r = (int)(p * 255.0);
						g = 0;
						b = 255;
					}
					else
					{
						p = p - 5.0 / 6.0;
						p = p * 6.0;
						r = 255;
						g = 0;
						b = (int)((1.0 - p) * 255.0);
					}
				}
				else
				{
					p = fabs(p - 0.5);
					p = p * 255.0;
					r = g = b = (int)p;
				}
			}
			else if(m == 2)
			{
				if(!colormode) r = g = b = (r + 2 * g + b) / 4;
			}

			if(r > 255) r = 255;
			if(g > 255) g = 255;
			if(b > 255) b = 255;
			if(r < 0) r = 0;
			if(g < 0) g = 0;
			if(b < 0) b = 0;
			screendata[i] = b;
			i++;
			screendata[i] = g;
			i++;
			screendata[i] = r;
			i++;
			screendata[i] = 0;
			i++;
		}
		if(WIDTH % 4 > 0){}//??
	}
}

// j[h}bv`
void CLayerView::CreateNeedleImage(int filemode)
{
	CWaitCursor wait;
	const int NEEDLEBLOCKSIZE = 16; // 2ȏ̋, cTCY̖񐔂Ƃꂢ
	const int NEEDLELENGTH = 14;
	int x, y;
	int c;
	int xx, yy;
	int xe, ye;
	int s;
	double nx, ny;

	// 
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			for(c = 0; c < 3; c++)
			{
				needleimage[x][y][c] = 0;
			}
		}
	}

	// Sɓ_ł
	for(x = NEEDLEBLOCKSIZE / 2; x < WIDTH; x += NEEDLEBLOCKSIZE)
	{
		for(y = NEEDLEBLOCKSIZE / 2; y < HEIGHT; y += NEEDLEBLOCKSIZE)
		{
			for(xx = x - 1; xx <= x + 1; xx++)
			{
				for(yy = y - 1; yy <= y + 1; yy++)
				{
					for(c = 0; c < 3; c++)
					{
						needleimage[xx][yy][c] = 255;
					}
				}
			}
		}
	}

	// j[h`
	for(x = NEEDLEBLOCKSIZE / 2; x < WIDTH; x += NEEDLEBLOCKSIZE)
	{
		for(y = NEEDLEBLOCKSIZE / 2; y < HEIGHT; y += NEEDLEBLOCKSIZE)
		{
			if(filemode == MIYA_NEEDLE)
			{
				nx = normal[x][y][AXISX];
				ny = normal[x][y][AXISY];
			}
			if(filemode == MIYA_NEEDLENEW)
			{
				nx = normalnew[x][y][AXISX];
				ny = normalnew[x][y][AXISY];
			}
			xe = x + (int)floor((double)NEEDLELENGTH * nx);
			ye = y + (int)floor((double)NEEDLELENGTH * ny);
			for(s = 0; s <= NEEDLELENGTH; s++)
			{
				xx = (NEEDLELENGTH - s) * x + s * xe;
				xx = (int)floor((double)xx / (double)NEEDLELENGTH + 0.5);
				yy = (NEEDLELENGTH - s) * y + s * ye;
				yy = (int)floor((double)yy / (double)NEEDLELENGTH + 0.5);
				if(xx >= 0 && xx < WIDTH && yy >= 0 && yy < HEIGHT)
				{
					for(c = 0; c < 3; c++)
					{
						needleimage[xx][yy][c] = 255;
					}
				}
			}
		}
	}
}

// _O摜vZ
void CLayerView::CreateRenderImage()
{
	CWaitCursor wait;
	int x, y;
	int c;
	double s;
	int r;

	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			s = shading(imageview, normalnew[x][y][AXISX], normalnew[x][y][AXISY], normalnew[x][y][AXISZ]);
			for(c = 0; c < 3; c++)
			{
				r = (int)floor(s * albedonew[x][y][c]);
				if(r < 0) r = 0;
				if(r > 255) r = 255;
				renderimage[x][y][c] = (unsigned char)r;
			}
		}
	}
}

// Photometric stereovZ
void CLayerView::OnCalcCalc()
{
	CWaitCursor wait;
	CTime ctStart;
	CTime ctEnd;
	CTimeSpan ctInterval;
	DWORD tickStart;
	DWORD tickEnd;
	DWORD tickInterval;
	CString str;
	int x, y;
	int c;
	double** Lfwd;
	double** Linv;
	double detL;
	int i;
	int j;
	double nx, ny, nz;
	double r;
	int k;
	int* sortintens;
	int* sortimage;
	int intensval;
	int img0, img1, img2;
	double nxsum, nysum, nzsum;
	double shade0, shade1, shade2;
	double w;
	double albedo0, albedo1, albedo2;
	const double ALBEDOMIN = 1.0;
	const double ALBEDOMAX = 255.0;

	// `FbN
	if(!processdone[MIYA_SHADING]) return;

	// Jnݒ
	ctStart = CTime::GetCurrentTime();
	tickStart = ::GetTickCount();

	// f[^i@͐ʂݒj
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			normal[x][y][AXISX] = 0.0;
			normal[x][y][AXISY] = 0.0;
			normal[x][y][AXISZ] = 1.0;
			albedo[x][y][COLR] = 0.0;
			albedo[x][y][COLG] = 0.0;
			albedo[x][y][COLB] = 0.0;
		}
	}

	// z̃m
	Lfwd = new double*[3];
	Linv = new double*[3];
	sortintens = new int[IMAGEMAX];
	sortimage = new int[IMAGEMAX];
	if(Lfwd == 0 || Linv == 0 || sortintens == 0 || sortimage == 0)
	{
		AfxMessageBox("܂");
		return;
	}
	for(i = 0; i < 3; i++)
	{
		Lfwd[i] = new double[3];
		Linv[i] = new double[3];
		if(Lfwd[i] == 0 || Linv[i] == 0)
		{
			AfxMessageBox("܂");
			return;
		}
	}

	// Axh̏lݒ
	for(y = 0; y < HEIGHT; y++)
	{
		for(x = 0; x < WIDTH; x++)
		{
			// Px\[gi}\[gjPx̒ႢႢCfbNXɂ
			for(i = 0; i < imagenum; i++)
			{
				sortintens[i] = INTINF;
				sortimage[i] = 0;
			}
			for(i = 0; i < imagenum; i++)
			{
				intensval = 0;
				intensval += (int)shadingimage[i][x][y][COLR] * (int)shadingimage[i][x][y][COLR];
				intensval += (int)shadingimage[i][x][y][COLG] * (int)shadingimage[i][x][y][COLG];
				intensval += (int)shadingimage[i][x][y][COLB] * (int)shadingimage[i][x][y][COLB];
				for(j = 0; j < i; j++)
				{
					if(intensval < sortintens[j]) break;
				}
				if(j < imagenum)
				{
					for(k = imagenum - 1; k > j; k--)
					{
						sortintens[k] = sortintens[k - 1];
						sortimage[k] = sortimage[k - 1];
					}
					sortintens[j] = intensval;
					sortimage[j] = i;
				}
			}

			// specularshadowƎvPx̃CfbNXRI
			i = (imagenum - 5) / 2;
			if(i < 0) i = 0;
			img0 = sortimage[i + 0];
			img1 = sortimage[i + 1];
			img2 = sortimage[i + 2];
			if(img0 == img1 || img1 == img2 || img2 == img0)
			{
				AfxMessageBox("vOɃoO܂");
				return;
			}
			if(img0 < 0 || img0 >= imagenum || img1 < 0 || img1 >= imagenum || img2 < 0 || img2 >= imagenum)
			{
				AfxMessageBox("vOɃoO܂");
				return;
			}
			if(!(sortintens[i+0] <= sortintens[i+1] && sortintens[i+1] <= sortintens[i+2] && sortintens[i+2] <= sortintens[imagenum-1]))
			{
				AfxMessageBox("vOɃoO܂");
				return;
			}

			// s쐬isj(img:,j:X,Y,Z)
			for(j = 0; j < 3; j++)
			{
				Lfwd[0][j] = lightpos[img0][j];
				Lfwd[1][j] = lightpos[img1][j];
				Lfwd[2][j] = lightpos[img2][j];
			}

			// tsvZ
			detL =
				Lfwd[0][0] * Lfwd[1][1] * Lfwd[2][2] +
				Lfwd[1][0] * Lfwd[2][1] * Lfwd[0][2] +
				Lfwd[2][0] * Lfwd[0][1] * Lfwd[1][2] -
				Lfwd[0][0] * Lfwd[2][1] * Lfwd[1][2] -
				Lfwd[2][0] * Lfwd[1][1] * Lfwd[0][2] -
				Lfwd[1][0] * Lfwd[0][1] * Lfwd[2][2];
			if(fabs(detL) < EPS)
			{
				AfxMessageBox("ȂƂɂȂĂ܂");
				return;
			}
			Linv[0][0] = Lfwd[1][1] * Lfwd[2][2] - Lfwd[1][2] * Lfwd[2][1];
			Linv[0][1] = Lfwd[0][2] * Lfwd[2][1] - Lfwd[0][1] * Lfwd[2][2];
			Linv[0][2] = Lfwd[0][1] * Lfwd[1][2] - Lfwd[0][2] * Lfwd[1][1];
			Linv[1][0] = Lfwd[1][2] * Lfwd[2][0] - Lfwd[1][0] * Lfwd[2][2];
			Linv[1][1] = Lfwd[0][0] * Lfwd[2][2] - Lfwd[0][2] * Lfwd[2][0];
			Linv[1][2] = Lfwd[0][2] * Lfwd[1][0] - Lfwd[0][0] * Lfwd[1][2];
			Linv[2][0] = Lfwd[1][0] * Lfwd[2][1] - Lfwd[1][1] * Lfwd[2][0];
			Linv[2][1] = Lfwd[0][1] * Lfwd[2][0] - Lfwd[0][0] * Lfwd[2][1];
			Linv[2][2] = Lfwd[0][0] * Lfwd[1][1] - Lfwd[0][1] * Lfwd[1][0];
			for(i = 0; i < 3; i++)
			{
				for(j = 0; j < 3; j++)
				{
					Linv[i][j] /= detL;
				}
			}

			// @vZ
			nxsum = 0.0;
			nysum = 0.0;
			nzsum = 0.0;
			for(c = 0; c < 3; c++)
			{
				// Px̖O̕tւ
				shade0 = (double)shadingimage[img0][x][y][c];
				shade1 = (double)shadingimage[img1][x][y][c];
				shade2 = (double)shadingimage[img2][x][y][c];

				// d݂vZ
				w = SQR((shade0 + shade1 + shade2) / 3.0);

				// @vZ
				nx = Linv[0][0] * shade0 + Linv[0][1] * shade1 + Linv[0][2] * shade2;
				ny = Linv[1][0] * shade0 + Linv[1][1] * shade1 + Linv[1][2] * shade2;
				nz = Linv[2][0] * shade0 + Linv[2][1] * shade1 + Linv[2][2] * shade2;
				r = NORM(nx, ny, nz); // {͂ꂪAxhɂȂĂ
				if(r > EPS)
				{
					nxsum += w * nx / r;
					nysum += w * ny / r;
					nzsum += w * nz / r;
				}
			}
			r = NORM(nxsum, nysum, nzsum);
			if(r > EPS)
			{
				normal[x][y][AXISX] = nxsum / r;
				normal[x][y][AXISY] = nysum / r;
				normal[x][y][AXISZ] = nzsum / r;
			}

			// AxhiPx܂ށjvZ
			for(c = 0; c < 3; c++)
			{
				// Px̖O̕tւ
				shade0 = (double)shadingimage[img0][x][y][c];
				shade1 = (double)shadingimage[img1][x][y][c];
				shade2 = (double)shadingimage[img2][x][y][c];

				// AxhvZ
				albedo0 = normal[x][y][AXISX] * lightpos[img0][AXISX] + normal[x][y][AXISY] * lightpos[img0][AXISY] + normal[x][y][AXISZ] * lightpos[img0][AXISZ];
				albedo1 = normal[x][y][AXISX] * lightpos[img1][AXISX] + normal[x][y][AXISY] * lightpos[img1][AXISY] + normal[x][y][AXISZ] * lightpos[img1][AXISZ];
				albedo2 = normal[x][y][AXISX] * lightpos[img2][AXISX] + normal[x][y][AXISY] * lightpos[img2][AXISY] + normal[x][y][AXISZ] * lightpos[img2][AXISZ];
				albedo0 = shade0 / albedo0;
				albedo1 = shade1 / albedo1;
				albedo2 = shade2 / albedo2;

				// Axhݒ
				if(albedo0 >= 0.0 && albedo1 >= 0.0 && albedo2 >= 0.0 && (SQR(shade0) + SQR(shade1) + SQR(shade2)) > EPS)
				{
					albedo[x][y][c] = (SQR(shade0) * albedo0 + SQR(shade1) * albedo1 + SQR(shade2) * albedo2)
						/ (SQR(shade0) + SQR(shade1) + SQR(shade2));
					if(albedo[x][y][c] < ALBEDOMIN) albedo[x][y][c] = ALBEDOMIN;
					if(albedo[x][y][c] > ALBEDOMAX) albedo[x][y][c] = ALBEDOMAX;
				}
			}
		}
	}

	// ̉
	for(i = 0; i < 3; i++)
	{
		delete [] Lfwd[i];
		delete [] Linv[i];
	}
	delete [] Lfwd;
	delete [] Linv;
	delete [] sortintens;
	delete [] sortimage;

	// ㏈
	processdone[MIYA_ALBEDO] = true;
	processdone[MIYA_ZENITH] = true;
	processdone[MIYA_AZIMUTH] = true;
	processdone[MIYA_NEEDLE] = true;
	processdone[MIYA_NORMAL] = true;
	viewmode = MIYA_ALBEDO;
	CheckView(viewmode);
	CreateImages();
	Invalidate();

	// IbZ[W
	ctEnd = CTime::GetCurrentTime();
	ctInterval = ctEnd - ctStart;
	tickEnd = ::GetTickCount();
	tickInterval = tickEnd - tickStart;
	str = "vZI܂\n";
	str += "\n";
	str += "Jn: " + ctStart.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "I: " + ctEnd.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "oߎ: " + ctInterval.Format("%H:%M:%S") + "\n";
	str.AppendFormat("oߎ: %dm~bn\n",  tickInterval);
	AfxMessageBox(str);
}

// ςvZ
double CLayerView::neighbor(double*** data, int x, int y, int a)
{
	double retval;
	int num;
	int xx, yy;
	int xy;

	retval = 0.0;
	num = 0;
	for(xy = 0; xy < 4; xy++)
	{
		if(xy == 0) {xx = x - 1; yy = y;}
		else if(xy == 1) {xx = x + 1; yy = y;}
		else if(xy == 2) {xx = x; yy = y - 1;}
		else {xx = x; yy = y + 1;}
		if(xx >= 0 && xx < WIDTH && yy >= 0 && yy < HEIGHT)
		{
			retval += data[xx][yy][a];
			num++;
		}
	}
	if(num == 0)
	{
		AfxMessageBox("vOɃoO܂");
		return 0.0;
	}
	return retval / (double)num;
}

// VF[fBOcosƂvZ
inline double CLayerView::shading(int i, double nx, double ny, double nz)
{
	return DOTPRODUCT(nx, ny, nz, lightpos[i][AXISX], lightpos[i][AXISY], lightpos[i][AXISZ]);
}

double CLayerView::Median(double* x, int n, double RANGEMIN, double RANGEMAX)
{
	const int LOOPMAX = 10;
	const double SIMILAR = (RANGEMAX - RANGEMIN) * 0.005;
	const double BIG = fabs(RANGEMAX) + fabs(RANGEMIN) + 1.0;
	const double AFAC = 1.5;
	const double AMP = 1.0;
	int np, nm, nz, j, loop;
	double xx, xp, xm, sumx, sum, eps, stemp, dum, ap, am, aa, a;

	if(n == 1) return x[0];
	if(n == 2) return (x[0] + x[1]) / 2.0;
	a = x[n - 1];
	eps = RANGEMAX - RANGEMIN;
	am = -(ap = BIG);
	for(loop = 0; loop < LOOPMAX; loop++)
	{
		sum = sumx = 0.0;
		np = nm = nz = 0;
		xm = -(xp = BIG);
		for(j = 0; j < n; j++)
		{
			xx = x[j];
			if(fabs(xx - a) < SIMILAR) nz++;
			else if(xx > a)
			{
				np++;
				if(xx < xp) xp = xx;
			}
			else
			{
				nm++;
				if(xx > xm) xm = xx;
			}
			dum = fabs(xx - a);
			if(dum < SIMILAR) dum = SIMILAR;
			dum = 1.0 / (eps + dum);
			sum += dum;
			sumx += xx * dum;
		}
		stemp = (sumx / sum) - a;
		if(nm <= (n + 1) / 2 && np <= (n + 1) / 2)
		{
			if(n % 2 == 0)
			{
				if(nz >= 2) return a;
				else if(np == nm) return (xm + xp) / 2.0;
				else if(np > nm) return (a + xp) / 2.0;
				else return (xm + a) / 2.0;
			}
			else
			{
				if(nz >= 1) return a;
				else if(np > nm) return xp;
				else return xm;
			}
		}
		if(np > nm)
		{
			am = a;
			aa = stemp < 0.0 ? xp : xp + stemp * AMP;
			if(aa > ap) aa = 0.5 * (a + ap);
			eps = AFAC * fabs(aa - a);
			a = aa;
		}
		else
		{
			ap = a;
			aa = stemp > 0.0 ? xm : xm + stemp * AMP;
			if(aa < am) aa = 0.5 * (a + am);
			eps = AFAC * fabs(aa - a);
			a = aa;
		}
	}
	return a;
}

// Photometric StereoŔvZ
void CLayerView::OnCalcIterate()
{
	CWaitCursor wait;
	double*** albedonow;
	double*** normalnow;
	int x, y;
	double** Lfwd;
	double** Linv;
	int i;
	int loop;
	int c;
	double r;
	const double ALBEDOMIN = 1.0;
	const double ALBEDOMAX = 255.0;
	int xx, yy;
	double s;
	double a;
	int img0, img1, img2;
	int j;
	double detL;
	double nxsum, nysum, nzsum;
	double shade0, shade1, shade2;
	double w;
	double nx, ny, nz;
	int* img0list;
	int* img1list;
	int* img2list;
	int* ilist;
	int k;
	int num;
	double* xnow;
	double* ynow;
	double* znow;
	double*** xlst;
	double*** ylst;
	double*** zlst;
	CTime ctStart;
	CTime ctEnd;
	CTimeSpan ctInterval;
	DWORD tickStart;
	DWORD tickEnd;
	DWORD tickInterval;
	CString str;
	int xy;
	double* aaround;
	double* aselect;
	CDC *pDC;
	CBitmap bitmap;
	CDC dcMemory;
	RECT rc;
	double aavg;
	double aopt;
	double xopt, yopt, zopt;
	double xavg, yavg, zavg;
	const double NORMALMIN = 0.01;
	const double CONVERGENCE = 0.99;
	double diffnowalbedo, diffnewalbedo, diffnownormal, diffnewnormal;
	const int COMBI = COMBINATION3(imagenum);
	double* meda;
	double* medn;

	// `FbN
	if(!processdone[MIYA_SHADING]) return;
	if(!processdone[MIYA_ALBEDO] || !processdone[MIYA_NORMAL]) return;

	// Jnݒ
	ctStart = CTime::GetCurrentTime();
	tickStart = ::GetTickCount();

	// m
	albedonow = new double**[WIDTH];
	normalnow = new double**[WIDTH];
	xlst = new double**[WIDTH];
	ylst = new double**[WIDTH];
	zlst = new double**[WIDTH];
	xnow = new double[4];
	ynow = new double[4];
	znow = new double[4];
	aaround = new double[4];
	aselect = new double[imagenum];
	meda = new double[imagenum + 4 * ALBEDOMED];
	medn = new double[COMBI + 4 * NORMALMED];
	for(x = 0; x < WIDTH; x++)
	{
		albedonow[x] = new double*[HEIGHT];
		normalnow[x] = new double*[HEIGHT];
		xlst[x] = new double*[HEIGHT];
		ylst[x] = new double*[HEIGHT];
		zlst[x] = new double*[HEIGHT];
		for(y = 0; y < HEIGHT; y++)
		{
			albedonow[x][y] = new double[3];
			normalnow[x][y] = new double[3];
			xlst[x][y] = new double[COMBI];
			ylst[x][y] = new double[COMBI];
			zlst[x][y] = new double[COMBI];
		}
	}
	Lfwd = new double*[3];
	Linv = new double*[3];
	for(i = 0; i < 3; i++)
	{
		Lfwd[i] = new double[3];
		Linv[i] = new double[3];
	}
	img0list = new int[COMBI];
	img1list = new int[COMBI];
	img2list = new int[COMBI];
	ilist = new int[imagenum];

	// gݍ킹vZiIԌ̐͂RŌŒjiint^32bit̏ꍇC摜̖32ȂƂȂj
	k = 0;
	for(i = 0; i < (1 << imagenum); i++)
	{
		num = 0;
		for(j = 0; j < imagenum; j++) ilist[j] = -1;
		for(j = 0; j < imagenum; j++)
		{
			if(i & (1 << j))
			{
				ilist[num] = j;
				num++;
			}
		}
		if(num == 3)
		{
			img0list[k] = ilist[0];
			img1list[k] = ilist[1];
			img2list[k] = ilist[2];
			k++;
		}
	}
	if(k != COMBI)
	{
		AfxMessageBox("vOɃoO܂");
		return;
	}

	// @̌炩ߌvZ
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			// SĂ̑gݍ킹ŋ߂@Xgɒǉ
			for(k = 0; k < COMBI; k++)
			{
				// ftHgl
				xlst[x][y][k] = 10000.0;
				ylst[x][y][k] = 10000.0;
				zlst[x][y][k] = 10000.0;

				// I΂ꂽR̌̔ԍ
				img0 = img0list[k];
				img1 = img1list[k];
				img2 = img2list[k];

				// s쐬isj(img:,j:X,Y,Z)
				for(j = 0; j < 3; j++)
				{
					Lfwd[0][j] = lightpos[img0][j];
					Lfwd[1][j] = lightpos[img1][j];
					Lfwd[2][j] = lightpos[img2][j];
				}

				// tsvZ
				detL =
					Lfwd[0][0] * Lfwd[1][1] * Lfwd[2][2] +
					Lfwd[1][0] * Lfwd[2][1] * Lfwd[0][2] +
					Lfwd[2][0] * Lfwd[0][1] * Lfwd[1][2] -
					Lfwd[0][0] * Lfwd[2][1] * Lfwd[1][2] -
					Lfwd[2][0] * Lfwd[1][1] * Lfwd[0][2] -
					Lfwd[1][0] * Lfwd[0][1] * Lfwd[2][2];
				if(fabs(detL) < EPS)
				{
					AfxMessageBox("ȂƂɂȂĂ܂");
					return;
				}
				Linv[0][0] = Lfwd[1][1] * Lfwd[2][2] - Lfwd[1][2] * Lfwd[2][1];
				Linv[0][1] = Lfwd[0][2] * Lfwd[2][1] - Lfwd[0][1] * Lfwd[2][2];
				Linv[0][2] = Lfwd[0][1] * Lfwd[1][2] - Lfwd[0][2] * Lfwd[1][1];
				Linv[1][0] = Lfwd[1][2] * Lfwd[2][0] - Lfwd[1][0] * Lfwd[2][2];
				Linv[1][1] = Lfwd[0][0] * Lfwd[2][2] - Lfwd[0][2] * Lfwd[2][0];
				Linv[1][2] = Lfwd[0][2] * Lfwd[1][0] - Lfwd[0][0] * Lfwd[1][2];
				Linv[2][0] = Lfwd[1][0] * Lfwd[2][1] - Lfwd[1][1] * Lfwd[2][0];
				Linv[2][1] = Lfwd[0][1] * Lfwd[2][0] - Lfwd[0][0] * Lfwd[2][1];
				Linv[2][2] = Lfwd[0][0] * Lfwd[1][1] - Lfwd[0][1] * Lfwd[1][0];
				for(i = 0; i < 3; i++)
				{
					for(j = 0; j < 3; j++)
					{
						Linv[i][j] /= detL;
					}
				}

				// @vZ
				nxsum = 0.0;
				nysum = 0.0;
				nzsum = 0.0;
				for(c = 0; c < 3; c++)
				{
					// Px̖O̕tւ
					shade0 = (double)shadingimage[img0][x][y][c];
					shade1 = (double)shadingimage[img1][x][y][c];
					shade2 = (double)shadingimage[img2][x][y][c];

					// d݂vZ
					w = SQR((shade0 + shade1 + shade2) / 3.0);

					// @vZ
					nx = Linv[0][0] * shade0 + Linv[0][1] * shade1 + Linv[0][2] * shade2;
					ny = Linv[1][0] * shade0 + Linv[1][1] * shade1 + Linv[1][2] * shade2;
					nz = Linv[2][0] * shade0 + Linv[2][1] * shade1 + Linv[2][2] * shade2;
					r = NORM(nx, ny, nz);
					if(r > EPS)
					{
						nxsum += w * nx / r;
						nysum += w * ny / r;
						nzsum += w * nz / r;
					}
				}
				r = NORM(nxsum, nysum, nzsum);
				if(r > EPS)
				{
					// @𐳋K
					nx = nxsum / r;
					ny = nysum / r;
					nz = nzsum / r;

					// @Xgɒǉ
					xlst[x][y][k] = nx;
					ylst[x][y][k] = ny;
					zlst[x][y][k] = nz;
				}
			}
		}
	}

	// f[^
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			normalnew[x][y][AXISX] = normal[x][y][AXISX];
			normalnew[x][y][AXISY] = normal[x][y][AXISY];
			normalnew[x][y][AXISZ] = normal[x][y][AXISZ];
			albedonew[x][y][COLR] = albedo[x][y][COLR];
			albedonew[x][y][COLG] = albedo[x][y][COLG];
			albedonew[x][y][COLB] = albedo[x][y][COLB];
		}
	}

	// vZ
	diffnowalbedo = INF;
	diffnownormal = INF;
	processdone[MIYA_ALBEDONEW] = true;
	viewmode = MIYA_ALBEDONEW;
	for(loop = 0; loop < LOOPNUM; loop++)
	{
		// rʂ\
		CreateImages();
		pDC = this->GetDC();
		this->GetClientRect(&rc);
		pDC->FillSolidRect(&rc, RGB(255,255,255));
		bitmap.CreateCompatibleBitmap(pDC, WIDTH, HEIGHT);
		bitmap.SetBitmapBits(WIDTH * HEIGHT * 4, screendata);
		dcMemory.CreateCompatibleDC(pDC);
		dcMemory.SelectObject(&bitmap);
		pDC->BitBlt(0, 0, WIDTH, HEIGHT, &dcMemory, 0, 0, SRCCOPY);
		bitmap.DeleteObject();
		dcMemory.DeleteDC();
		str.Format("[v%d Axh̍XV%f @̍XV%f", loop, diffnowalbedo, diffnownormal);
		pDC->DrawText(str, &rc, 0);
		this->ReleaseDC(pDC);

		// ČvZ
		for(x = 0; x < WIDTH; x++)
		{
			for(y = 0; y < HEIGHT; y++)
			{
				nx = normalnew[x][y][AXISX];
				ny = normalnew[x][y][AXISY];
				nz = normalnew[x][y][AXISZ];

				// Axȟ⃊Xg쐬
				for(c = 0; c < 3; c++)
				{
					for(xy = 0; xy < 4; xy++)
					{
						if(xy == 0) {xx = x - 1; yy = y;}
						else if(xy == 1) {xx = x + 1; yy = y;}
						else if(xy == 2) {xx = x; yy = y - 1;}
						else {xx = x; yy = y + 1;}

						aaround[xy] = 10000.0;
						if(xx >= 0 && xx < WIDTH && yy >= 0 && yy < HEIGHT)
						{
							// ߖT̃AxhXgɒǉ
							aaround[xy] = albedonew[xx][yy][c];
						}
					}

					// ݂̖@ł̃AxhXgɒǉ
					for(i = 0; i < imagenum; i++)
					{
						aselect[i] = 10000.0;
						s = shading(i, nx, ny, nz);
						if(s > EPS)
						{
							a = (double)shadingimage[i][x][y][c] / s;
							if(a > ALBEDOMIN && a < ALBEDOMAX) aselect[i] = a;
						}
					}

					// Axh̕ςvZ
					aavg = neighbor(albedonew, x, y, c);
					if(aavg < ALBEDOMIN) aavg = ALBEDOMIN;
					if(aavg > ALBEDOMAX) aavg = ALBEDOMAX;

					// fBAvZ邽߂̃Xg쐬
					num = 0;
					for(i = 0; i < imagenum; i++)
					{
						if(aselect[i] < 1000.0)
						{
							meda[num] = aselect[i];
							num++;
						}
					}
					for(i = 0; i < 4; i++)
					{
						if(aaround[i] < 1000.0)
						{
							for(j = 0; j < ALBEDOMED; j++)
							{
								meda[num] = aaround[i];
								num++;
							}
						}
					}

					// œKȃAxhvZ
					aopt = Median(meda, num, 0.0, 256.0);
					if(aopt < ALBEDOMIN || aopt > ALBEDOMAX) aopt = aavg;

					// AxhXV
					albedonow[x][y][c] = (aopt + ALBEDOAVG * aavg) / (1.0 + ALBEDOAVG);
				}

				// @̌⃊Xg쐬
				for(xy = 0; xy < 4; xy++)
				{
					if(xy == 0) {xx = x - 1; yy = y;}
					else if(xy == 1) {xx = x + 1; yy = y;}
					else if(xy == 2) {xx = x; yy = y - 1;}
					else {xx = x; yy = y + 1;}

					xnow[xy] = 10000.0;
					ynow[xy] = 10000.0;
					znow[xy] = 10000.0;
					if(xx >= 0 && xx < WIDTH && yy >= 0 && yy < HEIGHT)
					{
						// ߖT̖@Xgɒǉ
						xnow[xy] = normalnew[xx][yy][AXISX];
						ynow[xy] = normalnew[xx][yy][AXISY];
						znow[xy] = normalnew[xx][yy][AXISZ];
					}
				}

				// fBAvZ邽߂̃Xg쐬
				num = 0;
				for(i = 0; i < COMBI; i++)
				{
					if(xlst[x][y][i] < 1000.0)
					{
						medn[num] = xlst[x][y][i];
						num++;
					}
				}
				for(i = 0; i < 4; i++)
				{
					if(xnow[i] < 1000.0)
					{
						for(j = 0; j < NORMALMED; j++)
						{
							medn[num] = xnow[i];
							num++;
						}
					}
				}

				// @̃fBAI
				xopt = Median(medn, num, -1.0, 1.0);

				// fBAvZ邽߂̃Xg쐬
				num = 0;
				for(i = 0; i < COMBI; i++)
				{
					if(ylst[x][y][i] < 1000.0)
					{
						medn[num] = ylst[x][y][i];
						num++;
					}
				}
				for(i = 0; i < 4; i++)
				{
					if(ynow[i] < 1000.0)
					{
						for(j = 0; j < NORMALMED; j++)
						{
							medn[num] = ynow[i];
							num++;
						}
					}
				}

				// @̃fBAI
				yopt = Median(medn, num, -1.0, 1.0);

				// fBAvZ邽߂̃Xg쐬
				num = 0;
				for(i = 0; i < COMBI; i++)
				{
					if(zlst[x][y][i] < 1000.0)
					{
						medn[num] = zlst[x][y][i];
						num++;
					}
				}
				for(i = 0; i < 4; i++)
				{
					if(znow[i] < 1000.0)
					{
						for(j = 0; j < NORMALMED; j++)
						{
							medn[num] = znow[i];
							num++;
						}
					}
				}

				// @̃fBAI
				zopt = Median(medn, num, -1.0, 1.0);

				// @̃X[WOvZ
				xavg = neighbor(normalnew, x, y, AXISX);
				yavg = neighbor(normalnew, x, y, AXISY);
				zavg = neighbor(normalnew, x, y, AXISZ);

				// @XV
				nx = xopt + NORMALAVG * xavg;
				ny = yopt + NORMALAVG * yavg;
				nz = zopt + NORMALAVG * zavg;
				r = NORM(nx, ny, nz);
				if(r > EPS)
				{
					// @𐳋K
					nx /= r;
					ny /= r;
					nz /= r;

					// @Ԃꍇ
					if(nz < NORMALMIN)
					{
						r = NORM(nx, ny, 0.0);
						if(r > EPS)
						{
							nx /= r;
							ny /= r;
							nz = NORMALMIN;
							r = NORM(nx, ny, nz);
							if(r > EPS)
							{
								nx /= r;
								ny /= r;
								nz /= r;
							}
							else
							{
								AfxMessageBox("vOɃoO܂");
								return;
							}
						}
						else
						{
							nx = 0.0;
							ny = 0.0;
							nz = 1.0;
						}
					}
				}
				else
				{
					nx = normalnew[x][y][AXISX];
					ny = normalnew[x][y][AXISY];
					nz = normalnew[x][y][AXISZ];
				}
				normalnow[x][y][AXISX] = nx;
				normalnow[x][y][AXISY] = ny;
				normalnow[x][y][AXISZ] = nz;
			}
		}

		// l̍XVƕωʂ̌vZ
		diffnewalbedo = 0.0;
		diffnewnormal = 0.0;
		for(x = 0; x < WIDTH; x++)
		{
			for(y = 0; y < HEIGHT; y++)
			{
				diffnewalbedo += fabs(albedonew[x][y][COLR] - albedonow[x][y][COLR]);
				diffnewalbedo += fabs(albedonew[x][y][COLG] - albedonow[x][y][COLG]);
				diffnewalbedo += fabs(albedonew[x][y][COLB] - albedonow[x][y][COLB]);
				diffnewnormal += 1.0 - DOTPRODUCT(normalnew[x][y][AXISX], normalnew[x][y][AXISY], normalnew[x][y][AXISZ],
					normalnow[x][y][AXISX], normalnow[x][y][AXISY], normalnow[x][y][AXISZ]);
				albedonew[x][y][COLR] = albedonow[x][y][COLR];
				albedonew[x][y][COLG] = albedonow[x][y][COLG];
				albedonew[x][y][COLB] = albedonow[x][y][COLB];
				normalnew[x][y][AXISX] = normalnow[x][y][AXISX];
				normalnew[x][y][AXISY] = normalnow[x][y][AXISY];
				normalnew[x][y][AXISZ] = normalnow[x][y][AXISZ];
			}
		}
		if(diffnewalbedo < EPS || diffnowalbedo < EPS) {loop++; break;}
		if(diffnewalbedo / diffnowalbedo > CONVERGENCE && diffnewnormal / diffnownormal > CONVERGENCE) {loop++; break;}
		diffnowalbedo = diffnewalbedo;
		diffnownormal = diffnewnormal;
	}

	// 
	for(x = 0; x < WIDTH; x++)
	{
		for(y = 0; y < HEIGHT; y++)
		{
			delete [] albedonow[x][y];
			delete [] normalnow[x][y];
			delete [] xlst[x][y];
			delete [] ylst[x][y];
			delete [] zlst[x][y];
		}
		delete [] albedonow[x];
		delete [] normalnow[x];
		delete [] xlst[x];
		delete [] ylst[x];
		delete [] zlst[x];
	}
	delete [] albedonow;
	delete [] normalnow;
	delete [] xlst;
	delete [] ylst;
	delete [] zlst;
	for(i = 0; i < 3; i++)
	{
		delete [] Lfwd[i];
		delete [] Linv[i];
	}
	delete [] Lfwd;
	delete [] Linv;
	delete [] img0list;
	delete [] img1list;
	delete [] img2list;
	delete [] ilist;
	delete [] xnow;
	delete [] ynow;
	delete [] znow;
	delete [] aselect;
	delete [] aaround;
	delete [] meda;
	delete [] medn;

	// ㏈
	processdone[MIYA_ALBEDONEW] = true;
	processdone[MIYA_ZENITHNEW] = true;
	processdone[MIYA_AZIMUTHNEW] = true;
	processdone[MIYA_NEEDLENEW] = true;
	processdone[MIYA_NORMALNEW] = true;
	processdone[MIYA_RENDER] = true;
	viewmode = MIYA_ALBEDONEW;
	CheckView(viewmode);
	CreateImages();
	Invalidate();

	// IbZ[W
	ctEnd = CTime::GetCurrentTime();
	ctInterval = ctEnd - ctStart;
	tickEnd = ::GetTickCount();
	tickInterval = tickEnd - tickStart;
	str = "vZI܂\n";
	str += "\n";
	str += "Jn: " + ctStart.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "I: " + ctEnd.Format("%Y/%m/%d %H:%M:%S") + "\n";
	str += "oߎ: " + ctInterval.Format("%H:%M:%S") + "\n";
	str.AppendFormat("oߎ: %dm~bn\n",  tickInterval);
	str.AppendFormat(": %d \n", loop);
	AfxMessageBox(str);
}
